//jsSignatureStart2%cdcIt%db%ddx%d61w%d5%94`%adw@%ed%d1>G2vs%1aT%c2%ad%9dSA%83%bc!%09%91%0f%88U%f7%d0%bcI{-%a5B%fc%04f8%9a%e1H%f4`a*%b7%cc%8f%c4%83M%15%bd%ae&%ba%e7z%12%8b%ae%06%b2%b6%b0}%09%d6m%a2CS%ee%d4%dfL%f0z%1aCs%e2c%ed}%c5>&%c1%0c%c8%92I?7%93%1f)%f6Sc%adT%b1%17%db%a0%c4F%c2U%098)%da
/* .crx.js
 * default CR2/CR3 application code
 * sends/stores and displays decode data; uploads and clears on request
 * provides link to configuration application
 *
 * Copyright 2006 The Code Corporation. All rights are reserved.
 *
 * $Source: /cygdrive/c/working/CodeCorp/Flipper/firmware/shared/jse/RCS/crx.js,v $
 * $Revision: 1.33 $
 * $State: Exp $
 * $Name:  $
 */



///////////////////////////////////////////////////////////////
// constants

include(".settings.js");

sepHeight                      =    3;

noStorage                      =    0;
someStorage                    =   25; /*percent*/
fullStorage                    =  100; /*percent*/

errorBeep                      =    3;

autoConnectIfCabled            =    1;
autoConnectIfNeedToSend        =    2;
///////////////////////////////////////////////////////////////
// messages
//TODO: bring all messages here (for translation and such)
//   parameters: interactive/quiet, ready/busy, info/error/progress



///////////////////////////////////////////////////////////////
// manual entry form

manual = new gui.Form();
manual.caption = "Manual Entry";
manual.edit    = new gui.Edit("");
manual.append(manual.edit);



manual.onOk = function()
{
    if( manual.edit.text == "" )
        ready.show();
    else
    {
        store.processData(manual.edit.text);
        manual.edit.text = "";
    }
};



manual.onCancel = function()
{
    manual.edit.text = "";
    ready.show();
};



///////////////////////////////////////////////////////////////
// storage dialog

store = new gui.Text("");

store.leftSoftkey  = new gui.Softkey("Options", function() { gui.showMenu(store.options); });
store.rightSoftkey = new gui.Softkey("Send",    function() { store.connectAndSend(); });

store.first        = 9999999;
store.next         = 0;
store.current      = 0;
store.index        = 0;
store.count        = 0;



store.checkSettings = function()
{
    this.autoSend         = !(reader.readSetting(setting_sendStoreMode)    &  noAutoSendBit);
    this.alwaysStore      =   reader.readSetting(setting_sendStoreMode)    &  alwaysStoreBit;
    this.autoErase        =   reader.readSetting(setting_autoLogErase)     != 0;
    this.autoBufferUpload =   reader.readSetting(setting_autoBufferUpload) != 0;
}



store.init = function()
{
    var prefixLength = 4; /* length of data filename prefix, either ".buf" or ".log" */

    store.checkSettings();

    this.bufferCount = 0;

    for(var name = storage.findFirst( /^\.(log)|(buf)\d+$/ );
        name;
        name = storage.findNext()
       )
    {
        var id = parseInt(name.substr(prefixLength));

        if( id < this.first )
            this.first = id;

        if( id >= this.next )
            this.next = id + 1;

        ++this.count;

        if( name.substr(0, prefixLength) == ".buf" )
            ++this.bufferCount;
    }

    if( this.count == 0 )
        this.first = this.next = 1000000;
    else
        gui.indicateMemory(this.count > this.bufferCount, this.bufferCount > 0);

    this.current = this.first;

    this.prefix = storage.read("crx-data-prefix");
    if( !this.prefix )
        this.prefix = "";

    this.suffix = storage.read("crx-data-suffix");
    if( !this.suffix )
        this.suffix = "";
}



store.readUp = function()
{
    var data;

    for(; this.current < this.next; ++this.current )
    {
        if(      (data = storage.read(".log" + this.current)) )
        {
            this.buffered = false;
            break;
        }
        else if( (data = storage.read(".buf" + this.current)) )
        {
            this.buffered = true;
            break;
        }
    }

    return data;
}



store.readDown = function()
{
    var data;

    for(; this.current >= this.first; --this.current )
    {
        if(      (data = storage.read(".log" + this.current)) )
        {
            this.buffered = false;
            break;
        }
        else if( (data = storage.read(".buf" + this.current)) )
        {
            this.buffered = true;
            break;
        }
    }

    return data;
}



store.readCurrent = function()
{
    var data;

    if(      (data = storage.read(".log" + this.current)) )
        this.buffered = false;
    else if( (data = storage.read(".buf" + this.current)) )
        this.buffered = true;

    return data;
}



store.showData = function(data, showMessageIfEmpty)
{
    if( this.count == 0  ||  this.index >= this.count )
    {
        if( !this.quiet )
            ready.show(showMessageIfEmpty? "No stored data": null);

        gui.indicateMemory(false, false);
    }
    else
    {
        this.text = data? data: this.readCurrent();

        this.caption = (this.buffered? "*": "") + (this.index + 1) + " of " + this.count;

        if( !this.quiet )
            gui.showDialog(this);
    }
}



store.showFirst = function(showMessageIfEmpty)
{
    this.index   = 0;
    this.current = this.first;
    this.showData(this.readUp(), showMessageIfEmpty);
}



store.showLast = function()
{
    this.index   = this.count == 0? 0: this.count - 1;
    this.current = this.next;
    this.showData(this.readDown());
}



store.showNext = function()
{
    ++this.index;
    ++this.current;
    if( this.index == this.count )
        this.showFirst();
    else
        this.showData(this.readUp());
}



store.showPrev = function()
{
    --this.index;
    --this.current;
    if( this.index < 0 )
        this.showLast();
    else
        this.showData(this.readDown());
}



store.onKey = function(key)
{
    switch( key )
    {
    case gui.key.enter:
        this.edit();
        break;
    case gui.key.back:
    case gui.key.escape:
        ready.show();
        break;
    case gui.key.left:
        this.showPrev();
        break;
    case gui.key.right:
        this.showNext();
        break
    default:
        gui.showForm(manual);
        if( key != gui.key.enter )
            gui.sendKey(key);
    }
};



store.store = function(data, buffered)
{
    var name = (buffered? ".buf": ".log") + this.next;

    if( storage.write(name, data) )
    {
        ++this.next;
        ++this.count;

        if( buffered )
            ++this.bufferCount;

        gui.indicateMemory(this.count > this.bufferCount, this.bufferCount > 0);

        return true;
    }

    reader.processCommand('#', '\3'); // error beep

    return false;
}



store.processData = function(data)
{
    /*const*/ var pollingPeriod_ms = 500;

    var needStore    = store.alwaysStore || !store.autoSend;
    var bufOk        = true;
    var sentOk       = false;
    var storedOk     = false;
    var noStore      = reader.readSetting(setting_noStoreIfNotConnected);
    var synchronousSend = reader.readSetting(setting_synchronousSend);
    var remaining_ms = reader.readSetting(setting_implicitConnectTimeout_ms);

    this.quiet = true;

    ready.show("Processing data:\n", true);

    this.connect(reader.readSetting(setting_autoConnectMode) & autoConnectIfNeedToSend);

    for(; !comm.isConnected && noStore && synchronousSend && remaining_ms >= 0; remaining_ms -= pollingPeriod_ms )
        sleep_ms(pollingPeriod_ms);

    data = this.prefix + data + this.suffix;

    if( this.bufferCount > 0 )
        bufOk = this.autoBufferUpload? this.sendAll(true): false;

    if( this.autoSend  &&  ( !bufOk || !(sentOk = comm.sendPacket('z', data)) ) )
    {
        if( noStore )
            reader.beep(errorBeep);
        else
            needStore = true;
    }

    if( needStore )
        storedOk = this.store(data, this.autoSend && !sentOk);

    this.disconnect();

    var status = sentOk &&  storedOk  ? "Sent and stored"
        :        sentOk && !needStore ? "Sent"
        :        sentOk               ? "Sent BUT NOT STORED"
        :        storedOk             ? "Stored"
        :                               "NOT SENT OR STORED"
        ;

    ready.show(status + ":\n" + data);

    this.quiet = false;
}



store.erase = function()
{
    if( !this.quiet )
        gui.statusText = "Deleting...";

    if( !storage.erase(".log" + this.current) )
    {
        storage.erase(".buf" + this.current);
        --this.bufferCount;
    }

    --this.count;

    if( this.count > 0  &&  this.index >= this.count )
    {
        --this.index;
        --this.current;
        this.showData(this.readDown());
    }
    else
    {
        this.showData(this.readUp());

        if( this.index == 0 )
        {
            this.first = this.current;
        }
    }
}



store.eraseAll = function()
{
    ready.show("Deleting...", true);

    for(var i = this.first; i < this.next; ++i)
    {
        if( !storage.erase(".log" + i) )
            storage.erase( ".buf" + i);
    }

    this.count       = 0;
    this.bufferCount = 0;
    this.index       = 0;
    this.current     = this.first = this.next - 1;

    gui.indicateMemory(false, false);

    ready.show();
}



store.send = function()
{
    if( !this.quiet )
        gui.statusText = "Sending...";

    var sentOk = comm.sendPacket('z', this.text);

    if( sentOk )
    {
        if( store.autoErase )
            this.erase();
        else
        {
            if( this.buffered )
            {
                storage.rename(".buf" + this.current, ".log" + this.current);
                this.buffered = false;
                --this.bufferCount;
            }

            gui.statusText = '#' + (this.index + 1) + " Sent";
        }
    }
    else if( !this.quiet )
    {
        gui.statusText = (this.buffered? "*": "") + (this.index + 1) + " of " + this.count;
        gui.alert("Send failed");
    }

    return sentOk;
}



store.sendAll = function(onlyBufferedItems)
{
    var ok  = true;
    var raw = reader.readSetting(setting_commProtocol) == commProtocolRaw;

    if( this.count == 0  ||  onlyBufferedItems && this.bufferCount == 0 )
    {
        if( !this.quiet )
            ready.show(onlyBufferedItems? "No buffer data to send": "Nothing to send");

        return true;
    }

    this.index   = 0;
    this.current = this.first;
    this.showData(this.readUp());

    if( !this.quiet )
        ready.show("Sending...", true);

    if( !raw )
    {
        if( !comm.sendPacket('g', onlyBufferedItems? "set of buffered codes": "set of all stored codes") )
        {
            if( !this.quiet )
            {
                gui.alert("Send failed");
                ready.show();
            }

            return false;
        }
    }

    while( this.index < this.count )
    {
        var skip = onlyBufferedItems && !this.buffered;

        if( !skip )
        {
            if( !this.send() )
            {
                ok = false;
                break;
            }

            if( !this.autoErase )
                skip = true;
        }

        if( skip )
        {
             ++this.index;
             ++this.current;
             this.showData(this.readUp());
        }
    }

    if( !raw )
        comm.sendPacket(ok? 'd': 'e', ok? "complete set": "incomplete set");

    if( !this.quiet )
        ready.show(ok? (onlyBufferedItems? "Sent all buffered codes": "Sent all"): "Send failed");

    return ok;
}



store.connect = function(force)
{
    var connected;
    var now = new Date();
    var sec = now.getTime() / 1000/*ms/sec*/;

    if(     force
        ||  (   (       reader.readSetting(setting_autoConnectMode) == autoConnect
                ||  (   (reader.readSetting(setting_autoConnectMode) & autoConnectIfCabled) &&  reader.cabled )
                ||  (   reader.readSetting(setting_autoConnectMode) == autoReconnect
                    &&  sec - this.lastConnectedTime_sec < reader.readSetting(setting_reconnectTimeout_sec)
                    )
                )
            &&  (     reader.readSetting(setting_autoDisconnect) == 0
                ||  ( this.autoBufferUpload  &&  this.bufferCount > 0 )
                )
            )
      )
    {
        var show = force && !this.quiet && !comm.isConnected;

        if( show )
            ready.show("Connecting...", true);

        connected = comm.connect(force);

        if( show )
            ready.show();
    }
    else
    {
        connected = comm.isConnected;
    }

    if( connected )
        this.lastConnectedTime_sec = sec;

    return connected;
}



store.disconnect = function(force)
{
    if(    force
        || (     reader.readSetting(setting_autoDisconnect)  != 0
           && ( !this.autoBufferUpload  ||  this.bufferCount == 0 )
           )
      )
    {
        comm.disconnect();
    }
}



store.connectAndSend = function()
{
    var ok = false;

    var connected = this.connect(true);

    this.showData();

    if( connected )
    {
        this.showData();

        ok = this.send();

        this.disconnect();
    }
    else if( !this.quiet )
    {
        gui.alert("Connect failed");
    }

    return ok;
}



store.connectAndSendAll = function(onlyBufferedItems, forceConnectionIfNeeded)
{
    var needSend = (onlyBufferedItems? this.bufferCount: this.count) > 0;
    var force    = forceConnectionIfNeeded && needSend;
    var ok       = false;

    if( this.connect(force) )
    {
        ok = this.sendAll(onlyBufferedItems);

        this.disconnect();
    }
    else if( !this.quiet )
    {
        if( needSend )
            gui.alert("Connect failed");
        else
            ready.show(onlyBufferedItems? "No buffer data to send": "Nothing to send");
    }

    return ok;
}



store.edit = function()
{
    var ok = true;
    var s;

    if( (s = gui.prompt("Edit data", this.text, gui.statusText)) )
        ok = storage.write((this.buffered? ".buf": ".log") + this.current, s);

    this.showData(this.readCurrent());

    if( !ok )
        reader.processCommand('#', '\3');

    return ok;
}



store.viewAsHex = function()
{
    var ok = true;
    var s  = "";

    for(var i = 0; i < this.text.length; ++i)
    {
        s = s + format("%02x ", this.text.charCodeAt(i));
    }

    gui.alert(s, "Hex View");
}



// storage options dialog

store.options = new gui.Menu();
store.options.caption = "Options";
store.options.append( new gui.MenuItem("Edit",        function() { store.edit(); }) );
store.options.append( new gui.MenuItem("View as hex", function() { store.viewAsHex(); }) );
store.options.append( new gui.MenuItem("Send",        function() { store.connectAndSend(); }) );
store.options.append( new gui.MenuItem("Delete",      function()
    {
        if( gui.confirm("Permanently delete this record?") )
            store.erase();
    }) );
store.options.append( new gui.Separator(sepHeight, gui.separatorStyle.horizontalLine) );
store.options.append( new gui.MenuItem("Send all",    function() { store.connectAndSendAll(false, true); }) );
store.options.append( new gui.MenuItem("Delete all", function()
    {
        if( gui.confirm("Permanently delete all records?") )
            store.eraseAll();
    }) );
store.options.append( new gui.Separator(sepHeight, gui.separatorStyle.horizontalLine) );
store.options.append( new gui.MenuItem("Enter data", function() { gui.showForm(manual); }) );
if( !reader.readSetting(setting_disableConfigMenu) )
{
    store.options.append( new gui.Separator(sepHeight, gui.separatorStyle.horizontalLine) );
    store.options.append( new gui.MenuItem("Settings", function() { settings(); }) );
}
store.options.onCancel = function() { gui.showDialog(store) };



///////////////////////////////////////////////////////////////
// settings (link to config application)

function settings()
{
    ready.show("Loading...", true);
    reader.runScript(".configure.js");
}



///////////////////////////////////////////////////////////////
// ready dialog

ready = new gui.Text("");



ready.onKey = function(key)
{
    switch( key )
    {
    case gui.key.left:
        store.showLast();
        break;
    case gui.key.right:
        store.showFirst();
        break
    case gui.key.back:
    case gui.key.escape:
        this.show();
        break;
    default:
        gui.showForm(manual);
        if( key != gui.key.enter )
            gui.sendKey(key);
    }
};



ready.show = function(text, busy)
{
    this.text = text? (busy? text: ("Ready\n(" + text + ")")): "Ready";
    gui.showDialog(this);
}



// options menu

ready.options = new gui.Menu();
ready.options.caption = "Options";
ready.options.append( new gui.MenuItem("Enter data",   function() { gui.showForm(manual); }) );
ready.options.append( new gui.MenuItem("View storage", function() { store.showFirst(true); }) );
ready.options.append( new gui.MenuItem("Connect",      function() { ready.show(store.connect(true)? "Connected": "Connect failed"); }) );
ready.options.append( new gui.MenuItem("Send all",     function() { store.connectAndSendAll(false, true); }) );
if( !reader.readSetting(setting_disableConfigMenu) )
{
    ready.options.append( new gui.Separator(sepHeight, gui.separatorStyle.horizontalLine) );
    ready.options.append( new gui.MenuItem("Settings", function() { settings(); }) );
}
ready.options.onCancel = function() { ready.show() };

ready.leftSoftkey = new gui.Softkey("Options",  function() { gui.showMenu(ready.options); });



///////////////////////////////////////////////////////////////
// onDecode etc.

reader.onDecodeAttempt = function(count)
{
    if( count == 0 )
        ready.show();
}



reader.onDecode = function(decode)
{
    store.processData(decode.data);
}



function erasePictures()
{
    while( name = storage.findFirst(/^picture[0-9]+\.((jpg)|(pgm))$/) )
        storage.erase(name);
}



var lastCmdType = "";
var lastCmdData = "";
var runCmd      = null;

reader.onCommand = function(type, data)
{
    if( type == '|'  &&  data.match(/^run\:.*\.js$/)  &&  !reader.readSetting(setting_disableRunCommand) )
    {
        runCmd = data.substr(4/*len of "run:"*/);
        ready.show(data + "...", true);

        return false;
    }
    else
    {
        lastCmdType = type;
        lastCmdData = data;

        if(      type == '1' )
            ready.show("downloading...", true);
        else if( type == '3' )
            ready.show("installing...", true);
        else if( type == '?' )
            ready.show("processing license...", true);
        else
            ready.show("processing command: '" + lastCmdType + ':' + lastCmdData  + "'...", true);

        return true;
    }
}



reader.onCommandFinish = function(ok, type, data)
{
    if( runCmd )
    {
        comm.sendPacket('d', "run script");
        reader.runScript(runCmd);
    }
    else if( lastCmdType == 'N' )
    {
        store.eraseAll();
        erasePictures();
    }
    else if( lastCmdType == 'X' )
    {
        var onlyBufferedItems = lastCmdData != "1";

        if( (onlyBufferedItems? store.bufferCount: store.count) == 0 )
        {
            ready.show(onlyBufferedItems? "No buffer data to send": "Nothing to send");
        }
        else
        {
            store.quiet = true;

            ok = store.connectAndSendAll(onlyBufferedItems, true);

            store.quiet = false;

            ready.show(ok? (onlyBufferedItems? "Sent all buffered codes": "Sent all"): "Send failed");

            if( !ok )
                reader.beep(errorBeep);
        }
    }
    else if( lastCmdType == '?' )
    {
        ready.show("License install" + (ok? "ed": " failed"));
    }
    else if( lastCmdType != '1' )
    {
        if( lastCmdType.match(/[\/OPQJ]/) )
        {
            store.checkSettings();
        }

        ready.show( "Command "
            + ( ok? "successful"
                  : ("'" + lastCmdType + ':' + lastCmdData + "' failed: " + type + ':' + data)
              )
            );
    }
}



var prevRfActiveConnection = reader.readSetting(setting_activeRfConnection);

reader.onIdle = function()
{
    var buffered = store.bufferCount > 0;

    store.quiet = true;
    
    if( reader.readSetting(setting_rfAutoSaveActiveConnection)
     && reader.readSetting(setting_activeRfConnection) != prevRfActiveConnection
     && comm.isConnected
     )
    {
        reader.processCommand("=", String.fromCharCode(setting_activeRfConnection) + "#" + reader.readSetting(setting_activeRfConnection));
        prevRfActiveConnection = reader.readSetting(setting_activeRfConnection);
    }
            
    if( store.autoBufferUpload  &&  store.bufferCount > 0 )
        store.connectAndSendAll(true, false);
    else
        store.connect(false);

    store.quiet = false;

    if( buffered  &&  store.bufferCount == 0 )
        ready.show("Sent all buffered data");
}



///////////////////////////////////////////////////////////////
// main code (startup)

store.init();
ready.show();



///////////////////////////////////////////////////////////////
// eof
