//jsSignatureStartiZ%1dMtx%cd%88%d5|3E-%89%c2%c4oW*J\%b4%c0%e5r%9f%83`%1e%ac%cb%d6%8bL%82%16}}%e4%81%a9%dd%8d[%de%bd'%ce%e2%d9%03%96%e2%81%a4%bf%c4sE%d7%desh%15%c0%18%ab|%d8;[%dcv=%0c%f4%ab%a78:%9d%fd%d0u%bc%11%e1%b8:%10%0f%e4%90<%96%ac%ee7_%91<%11%a2%1f%a4%15%83%0a%92>s%a05%8dU%bd%d6%03%1a%1e[%16%8b[%80%f6%f7r
/* .jseLib.js
 *
 * Copyright 2006 The Code Corporation. All rights are reserved.
 * 
 * $Source: /cygdrive/c/working/CodeCorp/Flipper/firmware/shared/jse/RCS/jseLib.js,v $
 * $Revision: 1.48 $
 * $State: Exp $
 * $Name:  $
 *
 */
 


////////////////////////////////////////////////////////////////////////
// CR3 core objects



// constructors
gui.Form            = _Gui_List;
gui.Menu            = _Gui_List;
gui.MenuItem        = _Gui_MenuItem;
gui.Button          = _Gui_MenuItem;
gui.Edit            = _Gui_Edit;
gui.MultiLineEdit   = _Gui_MultiLineEdit;
gui.Label           = _Gui_StaticText;
gui.Softkey         = _Gui_Softkey;
gui.Text            = _Gui_Text;
gui.Separator       = _Gui_Separator;
gui.Image           = _Gui_Image;


gui._currentForm = null;
gui.leftSoftkey  = null;
gui.rightSoftkey = null;



// show
function _gui_show(f)
{
    gui._currentForm = f;
     
    gui.showNative(f);
}

gui.show = _gui_show;




// storage
function _storage_findFirst(re)
{
    storage._findRe = re;
    
    var name = storage.findFirstNative();
    
    while( name != null )
    {
        if( storage._findRe.test(name) )
            return name;
        else
            name = storage.findNextNative();
    }
    return null;
}

function _storage_findNext()
{
    var name = storage.findNextNative();
    
    while( name != null )
    {
        if( storage._findRe.test(name) )
            return name;
        else
            name = storage.findNextNative();
    }
}


storage.findFirst = _storage_findFirst;
storage.findNext  = _storage_findNext;



// append/prepend
function _List_append(i)
{
    this.children[this.children.length] = i;
    return this.appendNative(i);
}

function _List_prepend(i)
{
    for( i = this.children.length; i > 0; i-- )
    {
        this.children[i] = this.children[i - 1];
    }
        
    this.children[0] = i;
    
    return this.prependNative(i);
}

_Gui_List.prototype.children = new Array();

_Gui_List.prototype.append = _List_append;
_Gui_List.prototype.prepend = _List_prepend;



////////////////////////////////////////////////////////////////////////
// additional gui support, including form, menu, softkeys



// define send-key functions used by common softkeys

gui.sendEnter  = function() { gui.sendKey(gui.key.enter ); }
gui.sendEscape = function() { gui.sendKey(gui.key.escape); }



// create some common softkeys

gui.selectSoftkey = new gui.Softkey("Select", gui.sendEnter );
gui.okSoftkey     = new gui.Softkey("OK",     gui.sendEnter );
gui.backSoftkey   = new gui.Softkey("Back",   gui.sendEscape);
gui.cancelSoftkey = new gui.Softkey("Cancel", gui.sendEscape);



gui.showMenu = function(menu)
{
    // shows form along with appropriate softkeys
    // also shows caption, which is optional
    
    gui.statusText   = menu.caption;
    gui.leftSoftkey  = gui.selectSoftkey;
    gui.rightSoftkey = menu.onCancel? gui.backSoftkey: null;

    gui.show(menu);
}



gui.showSubMenu = function(menu, parentMenu)
{
    // links menu to parentMenu and shows it along with appropriate softkeys (and caption)

    menu.onCancel = function() { gui.showMenu(parentMenu); return true; };
    gui.showMenu(menu);
}



gui.showForm = function(form)
{
    // shows form along with appropriate softkeys;
    // also shows caption, which is optional

    gui.leftSoftkey  = form.leftSoftkey?  form.leftSoftkey:  gui.okSoftkey;
    gui.rightSoftkey = form.rightSoftkey? form.rightSoftkey: gui.cancelSoftkey;
    gui.statusText   = form.caption;

    gui.show(form);
}



gui.showDialog = function(dialog, caption)
{
    // shows dialog, including softkeys and caption

    gui.leftSoftkey  = dialog.leftSoftkey;
    gui.rightSoftkey = dialog.rightSoftkey;
    gui.statusText   = dialog.caption;

    gui.show(dialog);
}



// ToggleButton class

function _ToggleButton_toggle()
{
    // note: character 0x1f has been defined as a space of same width as '*'

    var checked = this.text.charAt(0) == '*';
    var text    = this.text.substring(1, this.text.length);
    checked     = !checked;
    this.text   = (checked? "*": "\x1f") + text;
    this.checked = checked;
    return this.onToggle(checked, this.text.substring(2/* excluding the space or '*' */)); 
}



function _ToggleButton_check(checked)
{
    var text  = this.text.substring(1, this.text.length);
    this.text = (checked? "*": "\x1f") + text;
    this.checked = checked;
    return this.onToggle(checked, this.text.substring(2/* excluding the space or '*' */));  
}



gui.ToggleButton = function(text, checked, onToggle)
{
    button = new gui.Button((checked? "*": "\x1f") + text, _ToggleButton_toggle);

    button.check = _ToggleButton_check;
    button.toggle = _ToggleButton_toggle;
 
    button.checked = checked;
 
    button.onToggle = onToggle;

    return button;
}


////////////////////////////////////////////////////////////////////////
// alert/prompt/confirm

function alert(s)
{
    gui.alert(s);
}

gui.alert = function(s, title)
{
    if( !title && title != "" )
        title = "Alert";

    function ok()
    {
        alert.flag = true;
    }

    alert.flag = false;
    
    alert.prevForm         = gui._currentForm;
    alert.prevLeftSoftkey  = gui.leftSoftkey;
    alert.prevRightSoftkey = gui.rightSoftkey;
    alert.prevStatusText   = gui.statusText;

    alert.f = new gui.Text(s.toString(), ok, ok);

    gui.leftSoftkey  = gui.okSoftkey;
    gui.rightSoftkey = new gui.Softkey("", ok);
    gui.statusText   = title;
    
    gui.show(alert.f);
    
    while( !alert.flag )
        sleep_ms(100);

    gui.leftSoftkey  = alert.prevLeftSoftkey;
    gui.rightSoftkey = alert.prevRightSoftkey;
    gui.statusText   = alert.prevStatusText;

    gui.show(alert.prevForm);
}



function confirm(s)
{
    return gui.confirm(s, null, "OK", "Cancel");
}

gui.confirm = function(s, title, yesText, noText)
{
    if( !title && title != "" )
        title = "Confirm";
    if( !yesText )
        yesText = "Yes";
    if( !noText )
        noText = "No";
        
    function yes()
    {
        confirm.flag = true;
        confirm.ret  = true;
    }

    function no()
    {
        confirm.flag = true;
        confirm.ret  = false;
    }

    confirm.flag = false;

    confirm.prevForm         = gui._currentForm;
    confirm.prevLeftSoftkey  = gui.leftSoftkey;
    confirm.prevRightSoftkey = gui.rightSoftkey;
    confirm.prevStatusText   = gui.statusText;

    confirm.f = new gui.Text(s.toString(), yes, no);

    gui.leftSoftkey  = new gui.Softkey(yesText, yes);
    gui.rightSoftkey = new gui.Softkey(noText,  no);
    gui.statusText   = title;
    
    gui.show(confirm.f);
    
    while( !confirm.flag )
        sleep_ms(100);

    gui.leftSoftkey  = confirm.prevLeftSoftkey;
    gui.rightSoftkey = confirm.prevRightSoftkey;
    gui.statusText   = confirm.prevStatusText;

    gui.show(confirm.prevForm);

    return confirm.ret;
}



function prompt(s, def)
{
    return gui.prompt(s, def);
}

gui.prompt = function(s, def, title)
{
    if( !title && title != "" )
        title = "Prompt";
        
    function onOk()
    {
        prompt.ok   = true;
        prompt.flag = true;
    }

    function onCancel()
    {
        prompt.ok   = false;
        prompt.flag = true;
    }

    prompt.flag = false;

    prompt.prevForm         = gui._currentForm;
    prompt.prevLeftSoftkey  = gui.leftSoftkey;
    prompt.prevRightSoftkey = gui.rightSoftkey;
    prompt.prevStatusText   = gui.statusText;

    prompt.f = new gui.Form(onOk, onCancel);

    prompt.f.append(new gui.Label(s.toString()));

    prompt.e = new gui.Edit(def);
    prompt.f.append(prompt.e);

    gui.leftSoftkey  = gui.okSoftkey;
    gui.rightSoftkey = gui.cancelSoftkey;
    gui.statusText   = title;
    
    gui.show(prompt.f);
 
    while( !prompt.flag )
        sleep_ms(100);

    gui.leftSoftkey  = prompt.prevLeftSoftkey;
    gui.rightSoftkey = prompt.prevRightSoftkey;
    gui.statusText   = prompt.prevStatusText;

    gui.show(prompt.prevForm);

    return prompt.ok ? prompt.e.text : null;
}



////////////////////////////////////////////////////////////////////
// setTimeout and setInterval
reader.timerId_ = 0;
reader.timers = new Array();

function Timer(func, interval, repeat, timerId)
{
    this.timerId = timerId;
    this.func = func;
    this.interval = interval;
    this.count = interval;
    this.repeat = repeat;
    this.toBeRemoved = false;
}



reader.setTimeout = function(func, delay_sec)
{
    var timer = new Timer(func, delay_sec, false, reader.timerId_);
    
    reader.timers.push(timer);
    
    return reader.timerId_++;
}



reader.setInterval = function(func, interval_sec)
{
    var timer = new Timer(func, interval_sec, true, reader.timerId_);

    reader.timers.push(timer);

    return reader.timerId_++;
}



reader.removeTimer = function(timerId)
{
    for( var i = 0; i < reader.timers.length; i++ )
    {
        if( reader.timers[i].timerId == timerId )
        { 
            reader.timers[i].toBeRemoved = true;
            break;
        }
    }
}


reader.clearTimeout = function(timeoutId)
{
    reader.removeTimer(timeoutId);
}



reader.clearInterval = function(intervalId)
{
    reader.removeTimer(intervalId);
}
  


reader.checkTimers = function()
{
    reader.checkTimers.toBeRemovedIds.length = 0;

    for( var i = 0; i < reader.timers.length; i++ )
    {
        if( reader.timers[i].toBeRemoved == true )
            reader.checkTimers.toBeRemovedIds.push(i);
    }
    
    for( var i = 0; i < reader.checkTimers.toBeRemovedIds.length; i++ )
    {
        reader.timers.splice(reader.checkTimers.toBeRemovedIds[i], 1);
    }
            
    for( var i = 0; i < reader.timers.length; i++ )
    {
        if( reader.timers[i].repeat )
        {
            if( --reader.timers[i].count == 0 )
            {
                reader.timers[i].func();
                reader.timers[i].count = reader.timers[i].interval;
            }                
        }
        else
        {
            if( --reader.timers[i].count == 0 )
            {
                reader.timers[i].func();
                reader.removeTimer(reader.timers[i].timerId);
            }                
        }
    }
}

reader.checkTimers.toBeRemovedIds = new Array();


reader.tick1Hz = function()
{
    reader.checkTimers();
}



//EOF
